/*****************************************************
Project : lentyajka
Version : 1.0
Date    : 29.06.2009

Chip type           : ATtiny13
Clock frequency     : 9,000000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 16
*****************************************************/

#include <tiny13.h>            
#include <delay.h>

#define OutLeft  PORTB.4  //  
#define OutRight PORTB.3  //  
#define Pulses         3  //  .  
#define PulsesThanks   2  //   ""


unsigned int flag = 0;      // 
unsigned int cnt  = 0;      //  

void RstRelay (void) //  
{
        OutLeft   = 0x00;
        OutRight  = 0x00;
        flag      = 0x00;
        cnt       = 0x00;
}

unsigned char GetData (void)
{
unsigned char i, j;
for(i=0;i<15;i++)  
  {                 
    delay_us(30);
    j = (PINB & 0x07); 
    delay_us(30);
    if(j != (PINB & 0x07)) i=0;
  }
return j;
}

void main(void)
{

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func5=In Func4=Out Func3=Out Func2=In Func1=In Func0=In 
// State5=T State4=0 State3=0 State2=P State1=P State0=P 
PORTB=0x07;
DDRB=0x18;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// Interrupt on any change on pins PCINT0-5: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
ACSR=0x80;
ADCSRB=0x00;

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/1024k
// Watchdog Timer interrupt: Off
#pragma optsize-
WDTCR=0x39;
WDTCR=0x29;

#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

while (1)
 {
  unsigned char dt   = 0;
  unsigned char puls = 0;
  
     dt = GetData(); //      
     //   210
     //   |||-     1 -  0 - 
     //   ||--    1 -  0 - 
     //   |---     1 - blink off 0 - blink on

     //   ""
     if ((flag == 0x01) && ((dt & 0x02) == 0x00)) RstRelay(); 
     if ((flag == 0x02) && ((dt & 0x01) == 0x00)) RstRelay(); 
     
     if ( (flag & 0x04) != 0x00)  //     .  
     {    
        if (dt == 0x03) flag = 0; // Blink    ,    ;
     }
     else 
     
     if ( (flag & 0x03) > 0x00) // -  
     {  
        if ( (dt & 0x04) == 0x04) //  , blink 
         {
           cnt +=1; 
           if ((flag & 0x03) == 0x03) puls = PulsesThanks;
           else puls = Pulses;
           if (cnt >= puls)
           {                 
              OutLeft   = 0x00;
              OutRight  = 0x00;
              flag      = 0x04;   
           }     
           else
           {
              while ( (dt & 0x04) == 0x04) //    blink
              {                         
                 dt = GetData();
                 #asm("wdr")  //  WDT
              } // while
           } // else
         }// if
     }// if
     else //   
     if (flag == 0x00) // -  
     {                         
       #asm("wdr")  //  WDT
       switch (dt & 0x03) //   
       {
        case 0x00: 
           OutLeft   = 0x00;
           OutRight  = 0x00;
           flag      = 0x04;   
           break; //         
/*           
           OutLeft   = 0x01;
           OutRight  = 0x01;
           flag      = 0x03;   
           break; //  ""
*/
        case 0x01:     
           cnt       = 0x00;  
           flag      = 0x02;
           OutRight  = 0x01;
        break;    //       
        case 0x02:    
           cnt       = 0x00;  
           flag      = 0x01;
           OutLeft   = 0x01;
        break;    //       
       } // switch
     } // if
 } // while
} // main
